#! /bin/sh
#
#   Module name 		: checkkey.sh 
#   Date of last delta		: 12/7/0
#   Release number		: 1.3


# Script name : checkkey.sh
# Purpose     : Checks if datakey device driver installed in unix kernel
# Author      : S. Roberts
# Revision    : 1.00

PATH=$PATH:. ; export PATH

# Fix to make Linux "echo" process escape characters
os=`uname -s`
if [ "x${os}" = "xLinux" ]
then
	. linfix.sh
fi


pause()
{
	echo
	echo "$spc Press [RETURN] to continue: \c"
	read nothing
}


su_check()
{
	# Test if SuperUser
	# If $proc = 0 then SuperUser
	proc=`id|sed s/uid=//|sed s/\(.*//`
}


find_op_sys()
{
	# Find out what Operating System currently using
	opsys=`uname -s`
	opsys=`echo $opsys|tr '[A-Z]' '[a-z]'`
}


all_ready_installed()
{
	# For SCO Xenix only.
	check=`cat /usr/sys/conf/link_xenix|grep DATAKEY.o`
}


# Main

# Define global variables
spc=""
proc=""
opsys=""
check=""

su_check
if [ $proc = 0 ]
then
	if [ -f /usr/sys/conf/link_xenix ]
	then
		# SCO Xenix
		all_ready_installed
		if [ -n "$check" ]
		then
			echo "$spc Security key installed."
		else
			echo "$spc Security key not installed."
		fi
	elif [ -f /etc/conf/cf.d/link_unix ]
	then
		# SCO Unix
		if [ -f /etc/conf/pack.d/tsx/Driver.o ]
		then
			echo "$spc Security key installed."
		else
			echo "$spc Security key not installed."
		fi
	elif [ -f /etc/conf/cf.d/unix ]
	then
		# 386ix
		if [ -f /usr/options/dtkey.name ]
		then
			echo "$spc Security key installed."
		else
			echo "$spc Security key not installed."
		fi
	else
		echo "$spc Sorry, not familiar with Operating System."
	fi
else
	echo
	echo
	echo "$spc You are not SuperUser. Can not continue."
	pause
	cls.sh
fi
