#! /bin/sh
#
#   Module name 		: checkperm1.sh 
#   Date of last delta		: 12/7/0
#   Release number		: 1.3


# Revision 1.00

# Fix to make Linux "echo" process escape characters
os=`uname -s`
if [ "x${os}" = "xLinux" ]
then
	. linfix.sh
fi


if [ "x$2" = "x-v" ]
then
	echo "Checking $1"
fi

if [ -d $1 ]
then
	# Check directory permissions for +rwx
	if [ ! \( -r $1 -a -w $1 -a -x $1 \) ]
	then
		echo "Directory $1 has insufficient permissions"
	fi
else
	# Check file permissions for +rw
	if [ ! \( -r $1 -a -w $1 \) ]
	then
		echo "File $1 has insufficient permissions"
	fi
fi
