#! /bin/sh
#
#   Module name 		: lp.sh 
#   Date of last delta		: 12/7/0
#   Release number		: 1.3
#

#  @(#)Script name : lp.sh
#  @(#)Description : Print a file to selected queue
#      Author      : S. Roberts
#  @(#)Revision    : 1.00


# Fix to make Linux "echo" process escape characters
os=`uname -s`
if [ "x${os}" = "xLinux" ]
then
	. linfix.sh
fi


pause()
{
	echo
	echo "$spc Press <RETURN> to continue: \c"
	read nothing
}


get_f_name()
{
	while [ ! -f "$f_name" ]
	do
		echo $cls
		echo
		echo "$spc Enter filename to print: $st_bl\c"
		read f_name
		echo $norm
		if [ ! -f "$f_name" ]
		then
			echo
			echo "$spc Invalid filename."
			pause
		fi
	done
}


get_names()
{
	lpstat -v | sed "s/.*for //;s/\:.*//" > /tmp/lp.$$
}


get_name()
{
	name=`sed "$1 q" < /tmp/lp.$$ 2> /dev/null|tail -1`
}


printer_menu()
{
	ex_flag=false

	while [ $ex_flag = false ]
	do
		top_item=0
		echo $cls
		echo
		echo "$spc$st_us Available Printers $norm"
		echo

		for a
		do
			top_item=`expr $top_item + 1`
			echo "$spc   $st_bl$top_item$norm   $a"
		done

		echo
		echo "$spc Select option: $st_bl\c"
		read opt
		echo "$norm\c"

		if [ -z "`echo $opt|tr -d '[0-9]'`" ]
		then
			if [ "$opt" -gt 0 -a "$opt" -le $top_item ]
			then
				get_name $opt
				ex_flag=true
			fi
		fi
	done
}


not_active()
{
	echo
	echo "$spc Printer is not active."
	echo
	if [ "`echo $f_name | sed 's/UPDNOTE.*/UPDNOTE/'`" = UPDNOTE ]
	then
		echo "$spc To print the Update Note at another time, type:"
		echo
		echo "$spc    lp.sh $f_name"
		echo
		echo "$spc from the UBL system software directory."
		echo
	else
		echo "$spc Abort."
		echo
	fi
}


indirect_approach()
{
	if [ `cat /tmp/lp.$$ | wc -l` = 1 ]
	then
		name=`cat /tmp/lp.$$`
	else
		printer_menu `cat /tmp/lp.$$`
	fi
	active=`lpstat -p $name | grep enable`
	if [ -z "$active" ]
	then
		not_active
	else
		get_f_name
		pr $f_name | lp -d$name
	fi
}


print_direct()
{
	get_f_name
	cat $f_name > $device
	echo "Request sent to printer"
}


direct_approach()
{
	device=
	until [ -c "$device" ]
	do
		echo $cls$st_bl > /tmp/mess.$$
		echo "UNIX printer services not available." >> /tmp/mess.$$
		echo "Available printer divices:$norm" >> /tmp/mess.$$
		echo >> /tmp/mess.$$
		ls -C /dev/lp* 2>/dev/null >> /tmp/mess.$$
		echo >> /tmp/mess.$$
		more /tmp/mess.$$
		rm -f /tmp/mess.$$ 2>/dev/null

		echo "Device: $st_bl\c"
		read device
		echo "$norm\c"
	done
	echo
	echo "Using device $device"
	pause
	print_direct
}


f_name=$1
st_bl=`tput bold 2>/dev/null`
st_us=`tput smul 2>/dev/null`
norm=`tput sgr0 2>/dev/null`
cls=`tput clear 2>/dev/null`
spc=


rm -f /tmp/lp.$$ 2>/dev/null
get_names
if [ -s /tmp/lp.$$ ]
then
	indirect_approach
else
	direct_approach
fi
rm /tmp/lp.$$
