#! /bin/sh
#
#   Module name 		: modenv.sh 
#   Date of last delta		: 12/7/0
#   Release number		: 1.3


# Script name : modenv.sh
# Purpose     : Modify BBENV file using UBL program 'bbenvmod'.
# Author      : S. Roberts
# Revision    : 1.00


PATH=$PATH:. ; export PATH

# Fix to make Linux "echo" process escape characters
os=`uname -s`
if [ "x${os}" = "xLinux" ]
then
	. linfix.sh
fi


set_attrs()
{
	case "$TERM" in
		vt100 | vt220 | vt320 | xterm | ansi )
					st_bl=`tput bold 2>/dev/null`;
					st_us=`tput smul 2>/dev/null`;
					norm=`tput sgr0 2>/dev/null`;;

		* )			st_bl=;
					st_us=;
					norm=;;
	esac
}


menu()
{
	# $1 = Message, $2 = File or Directory, $3 = Path
	level_back=false
	echo
	echo "$spc DEFAULT $1 [$st_bl$3$norm]   Rev $rev"
	echo "$spc Enter 'q' to QUIT '^' to GO BACK  'd' for DEFAULT or \c"
	if [ $2 = "dir" ]
	then
		echo "NEW DIRECTORY"
	else
		echo "NEW FILE NAME"
	fi
	ex_flag=false
	while [ $ex_flag = false ]
	do
		echo "$spc Select option: $st_bl\c"
		read choice
		echo "$norm\c"
		case $choice in
			"^" )		ex_flag=true;;
			q | Q )		exit 1;;
			d | D )		choice=$3;
					ex_flag=true;;
			"" )		;;
			* )		ex_flag=true;;
		esac
	done
}


yes_or_no()
{
	echo "$st_bl\c"
	read confirm
	echo "$norm\c"
	confirm=${confirm:-"n"}
	confirm=`echo $confirm|tr '[A-Z]' '[a-z]'`
}


find_bbenv()
{
	#env_path=`find / -name "BBENV" -print 2>/dev/null | sed "1q"`
	if [ -f "$BBENV" ]
	then
		env_path=$BBENV
	else
		env_path=`where.sh BBENV f`
	fi
}


level1()
{
	choice=""
	ex_flag1=false
	while [ $ex_flag1 = false -a $completed = false ]
	do
		cls.sh
		menu "UBL System Software Directory" "dir" "$ubb_path"
		if [ "$choice" != "^" ]
		then
			ubb_path=$choice
			level2
		else
			exit 2
		fi
	done
}


level2()
{
	choice=""
	ex_flag2=false
	if [ -n "$BBENV" ]
	then
		env_path=$BBENV
	else
		find_bbenv
	fi
	while [ $ex_flag2 = false -a $completed = false ]
	do
		menu "Full pathname to BBENV file" "file" "$env_path"
		if [ "$choice" != "^" ]
		then
			env_path=$choice
			call_ubb
			completed=true
		else
			ex_flag2=true
			ex_flag1=false
		fi
	done
}


call_ubb()
{
	if [ -f "$ubb_path/ubl" ]
	then
		if [ -f "$env_path" ]
		then
			if [ -n "`grep BBLIB $env_path`" ]
			then
				BBBYE=Y; export BBBYE
				BBENV=$env_path; export BBENV
				$ubb_path/ubl bbenvmod
			else
				echo "BBLIB not found in BBENV."
			fi
		else
			echo "$env_path not found"
		fi
	else
		echo "$ubb_path/ubl not found"
	fi
}


# Main

rev="1.00"
# Global variables:
set_attrs
spc=""
ex_flag1=false
ex_flag2=false
completed=false
opt=""
choice=""
if [ -z "$ubb_path" ]
then
	ubb_path=`where.sh ubl x`
	if [ -z "${ubb_path}" ]
	then
	    ubb_path='.'
	else
	    ubb_path=`dirname $ubb_path`
	fi
fi
env_path=""


level1
