#! /bin/sh
#
#   Module name 		: modperm.sh 
#   Date of last delta		: 12/7/0
#   Release number		: 1.3


# Script name : modperm.sh
# Purpose     : Modify permissions for directory and files if needed.
# Author      : S. Roberts
# Revision    : 1.00


PATH=$PATH:. ; export PATH

# Fix to make Linux "echo" process escape characters
os=`uname -s`
if [ "x${os}" = "xLinux" ]
then
	. linfix.sh
fi


set_attrs()
{
	case "$TERM" in
		vt100 | vt220 | vt320 | xterm | ansi )
					st_bl=`tput bold 2>/dev/null`;
					st_us=`tput smul 2>/dev/null`;
					norm=`tput sgr0 2>/dev/null`;;

		* )			st_bl=;
					st_us=;
					norm=;;
	esac
}


menu()
{
	cls.sh
	echo
	echo "$spc Directories will be modified to +rwx"
	echo "$spc Files will be modified to +rw"
	echo
	echo "$spc Modify Permissions For DEFAULT Directory [$st_bl`pwd`$norm]   Rev $rev"
	echo "$spc Enter 'q' to QUIT, '^' to GO BACK, 'd' for DEFAULT or New Directory"
	echo
}


pause()
{
	echo
	echo "$spc Press [RETURN] to continue: \c"
	read nothing
}


su_check()
{
	# Test if SuperUser
	# If $proc = 0 then SuperUser.
	proc=`id|sed s/uid=//|sed s/\(.*//`
}


permod()
{
	if [ -d $chk_path ]
	then
		echo
		echo "$spc Please wait ..."
		echo
		echo
		find $chk_path -exec modperm1.sh {} $verbose \; 2>/dev/null
		echo
		echo "$spc Finished."
		ex_flag1=true;
	else
		echo
		echo "$spc Directory $chk_path not found."
		pause
	fi
}
	



# main
rev="1.00"
verbose=$1
set_attrs
spc=""
ex_flag1=false
chk_path=""
proc=""

su_check
if [ $proc = 0 ]
then
	while [ $ex_flag1 = false ]
	do
		menu
		echo "$spc Select option: $st_bl\c"
		read opt
		echo "$norm\c"
		case $opt in
			q | Q )		exit 1;;
			"^" )		exit 2;;
			d | D )		chk_path=`pwd`;
					permod;;
			"" )		;;
			* )		chk_path=$opt;
					permod;;
		esac
	done
else
	echo
	echo
	echo "$spc You are not SuperUser. Can not continue."
	echo
fi
