#! /bin/sh
#
#   Module name 		: runublmon.sh 
#   Date of last delta		: 12/7/0
#   Release number		: 1.3


# Script name : runublmon.sh
# Purpose     : Run UBL Monitor.
# Author      : S. Roberts
# Revision    : 1.00


PATH=$PATH:. ; export PATH

# Fix to make Linux "echo" process escape characters
os=`uname -s`
if [ "x${os}" = "xLinux" ]
then
	. linfix.sh
fi


set_attrs()
{
	case "$TERM" in
		vt100 | vt220 | vt320 | xterm | ansi )
					st_bl=`tput bold 2>/dev/null`;
					st_us=`tput smul 2>/dev/null`;
					norm=`tput sgr0 2>/dev/null`;;

		* )			st_bl=;
					st_us=;
					norm=;;
	esac
}


menu()
{
	cls.sh
	echo
	echo "$spc$st_us RUN $UBLMON $norm  Rev $rev"
	echo
	echo "$spc DEFAULT $PROD System Software Directory [$st_bl$ubb_path$norm]"
	echo "$spc Enter 'q' to QUIT, '^' to GO BACK, 'd' for DEFAULT or NEW DIRECTORY"
	echo
}


menu2()
{
	echo
	echo "$spc Do you want to run `echo $UBLMON | tr '[A-Z]' '[a-z]'`\c"
	echo " in windows mode?"
	echo "$spc Enter 'q' to QUIT, '^' to GO BACK, 'Y' or 'N'"
	echo
}


pause()
{
	echo
	echo "$spc Press [RETURN] to continue: \c"
	read nothing
}


call_ubbmon()
{
	if [ -f $ubb_path/$ubbmon ]
	then
		ex_flag2=false
		while [ $ex_flag2 = false ]
		do
			menu2
			echo "$spc Select option: $st_bl\c"
			read opt
			echo "$norm\c"
			case $opt in
				q | Q )		exit 1;;
				"^" )		ex_flag2=true;;
				y | Y )		$ubb_path/$ubbmon -w;
						ex_flag2=true;
						ex_flag1=true;;
				n | N )		$ubb_path/$ubbmon;
						ex_flag2=true;
						ex_flag1=true;;
				* )		cls.sh;;
			esac
		done
	else
		echo
		echo "$spc $ubb_path/$ubbmon not found"
		ubb_path=$old_path
		pause
	fi
}


# main program
rev="1.00"
set_attrs
if [ -n "`pwd | grep usql`" ]
then
	PROD="U/SQL"
	ubbmon=progs/ublmon
	UBLMON=MONITOR
	if [ -z "$ubb_path" ]
	then
		ubb_path=`where.sh runusql f`
		if [ -z "${ubb_path}" ]
		then
		    ubb_path='.'
		else
		    ubb_path=`dirname $ubb_path`
		fi
	fi
else
	PROD="UBL"
	ubbmon=ublmon
	UBLMON=UBLMON
	if [ -z "$ubb_path" ]
	then
		ubb_path=`where.sh ublmon x`
		if [ -z "${ubb_path}" ]
		then
		    ubb_path='.'
		else
		    ubb_path=`dirname $ubb_path`
		fi
	fi
fi
spc=""

ex_flag1=false
ex_flag2=false
while [ $ex_flag1 = false ]
do
	menu
	echo "$spc Select option: $st_bl\c"
	read opt
	echo "$norm\c"
	case $opt in
		q | Q )		exit 1;;
		"^" )		exit 2;;
		d | D )		call_ubbmon;;
		"" )		;;
		* )		old_path=$ubb_path
				ubb_path=$opt;
				call_ubbmon;;
	esac
done
