#! /bin/sh
#
#   Module name 		: startrun.sh 
#   Date of last delta		: 12/7/0
#   Release number		: 1.5


# Script name : startrun.sh
# Purpose     : Start UBL runtime.
# Author      : S. Roberts
# Revision    : 1.00


PATH=$PATH:. ; export PATH

# Fix to make Linux "echo" process escape characters
os=`uname -s`
if [ "x${os}" = "xLinux" ]
then
	. linfix.sh
fi


set_attrs()
{
	case "$TERM" in
		vt100 | vt220 | vt320 | xterm | ansi )
					st_bl=`tput bold 2>/dev/null`;
					st_us=`tput smul 2>/dev/null`;
					norm=`tput sgr0 2>/dev/null`;;

		* )			st_bl=;
					st_us=;
					norm=;;
	esac
}


menu()
{
	cls.sh
	echo
	echo "$spc$st_us START $PROD RUNTIME $norm  Rev $rev"
	echo
	echo "$spc DEFAULT Banner file [$st_bl$ban_name$norm]"
	echo "$spc Enter 'q' to QUIT, '^' to GO BACK, 'd' for DEFAULT or NEW FILE"
	echo
}


check_shared_memory()
{
	active=`ipcs -m|grep 0x00001b63`
}


find_banner()
{
	ban_name=`where.sh "*.[Bb][Aa][Nn]" f`
}


menu2()
{
	echo
	echo "$spc DEFAULT $PROD System Software Directory [$st_bl$ubb_path$norm]"
	echo "$spc Enter 'q' to QUIT, '^' to GO BACK, 'd' for DEFAULT or NEW DIRECTORY"
	echo
}


find_ubbmon()
{
	if [ -f $ban_name ]
	then
		ex_flag3=false
		while [ $ex_flag3 = false ]
		do
			menu2
			echo "$spc Select option: $st_bl\c"
			read opt
			echo "$norm\c"
			case $opt in
				q | Q )		exit 1;;
				"^" )		ex_flag3=true;;
				d | D )		start_runtime;;
				"" )		cls.sh;;
				* ) 		ubb_path=$opt;
						start_runtime;;
			esac
		done
	else
		echo
		echo "$spc $ban_name not found"
		echo
	fi
}


start_runtime()
{
	if [ -f $ubb_path/$ubbmon ]
	then
		$ubb_path/$ubbmon $ban_name s Q
		ex_flag3=true
		ex_flag2=true
		echo
		echo "$spc Runtime now installed."
	else
		echo
		echo "$spc $ubb_path/$ubbmon not found"
	fi
}


long_winded()
{
	find_banner
	ex_flag2=false
	while [ $ex_flag2 = false ]
	do
		menu
		echo "$spc Select option: $st_bl\c"
		read opt
		echo "$norm\c"
		case $opt in
			q | Q )		exit 1;;
			"^" )		exit 2;;
			d | D )		find_ubbmon;;
			"" )		;;
			* )		ban_name=$opt;
					find_ubbmon;;
		esac
	done
}


bbenv_ent()
{
	# Find a BBENV entry and echo it
	grep "^$1=" $ubb_path/BBENV| sed "s/$1=//"
}


# main program
rev="1.00"
quick=$1
if [ -n "`pwd | grep usql`" ]
then
	PROD="U/SQL"
	ubbmon=progs/ublmon
	if [ -z "$ubb_path" ]
	then
		ubb_path=`where.sh runusql f`
		if [ -z "${ubb_path}" ]
		then
		    ubb_path='.'
		else
		    ubb_path=`dirname $ubb_path`
		fi
	fi
else
	PROD="UBL"
	ubbmon=ublmon
	if [ -z "$ubb_path" ]
	then
		ubb_path=`where.sh ublmon x`
		if [ -z "${ubb_path}" ]
		then
		    ubb_path='.'
		else
		    ubb_path=`dirname $ubb_path`
		fi
	fi
fi
set_attrs
spc=""
ban_name=""
active=""
ex_flag2=false
ex_flag3=false

check_shared_memory
if [ ! "$active" ]
then
	if [ "x$quick" = "x-q" ]
	then
		ban_name=`bbenv_ent BBSIGNON`
		if [ -z "$ban_name" ]
		then
			long_winded
		else
			start_runtime
		fi
	else
		long_winded
	fi
else
	echo
	echo "$spc $PROD Runtime already installed."
	echo
fi
