#! /bin/sh
#
#   Module name 		: stoprun.sh 
#   Date of last delta		: 12/7/0
#   Release number		: 1.5


# Script name : stoprun.sh
# Purpose     : Stop UBL runtime.
# Author      : S. Roberts
# Revision    : 1.00


PATH=$PATH:. ; export PATH

# Fix to make Linux "echo" process escape characters
os=`uname -s`
if [ "x${os}" = "xLinux" ]
then
	. linfix.sh
fi


set_attrs()
{
	case "$TERM" in
		vt100 | vt220 | vt320 | xterm | ansi )
					st_bl=`tput bold 2>/dev/null`;
					st_us=`tput smul 2>/dev/null`;
					norm=`tput sgr0 2>/dev/null`;;

		* )			st_bl=;
					st_us=;
					norm=;;
	esac
}


menu()
{
	cls.sh
	echo
	echo "$spc$st_us STOP $PROD RUNTIME $norm  Rev $rev"
	echo
	echo "$spc DEFAULT $PROD System Software Directory [$st_bl$ubb_path$norm]"
	echo "$spc Enter 'q' to QUIT, '^' to GO BACK, 'd' for DEFAULT or NEW DIRECTORY"
	echo
}


check_shared_memory()
{
	active=`ipcs -m|grep 0x00001b63`
}


kill_runtime()
{
	if [ -f $ubb_path/$ubbmon ]
	then
		$ubb_path/$ubbmon dummy K Q
		ex_flag1=true
		echo
		echo "$spc Runtime is no longer installed."
	else
		echo
		echo "$spc $ubb_path/$ubbmon not found"
	fi
}


# main program
rev="1.00"
set_attrs
if [ -n "`pwd | grep usql`" ]
then
	PROD="U/SQL"
	if [ -z "$ubb_path" ]
	then
		ubb_path=`where.sh runusql f`
		if [ -z "${ubb_path}" ]
		then
		    ubb_path='.'
		else
		    ubb_path=`dirname $ubb_path`
		fi
	fi
	ubbmon=progs/ublmon
else
	PROD="UBL"
	if [ -z "$ubb_path" ]
	then
		ubb_path=`where.sh ublmon x`
		if [ -z "${ubb_path}" ]
		then
		    ubb_path='.'
		else
		    ubb_path=`dirname $ubb_path`
		fi
	fi
	ubbmon=ublmon
fi
spc=""
active=""
ex_flag1=false

check_shared_memory
if [ "$active" ]
then
	ex_flag1=false
	while [ $ex_flag1 = false ]
	do
		menu
		echo "$spc Select option: $st_bl\c"
		read opt
		echo "$norm\c"
		case $opt in
			q | Q )		exit 1;;
			"^" )		exit 2;;
			d | D )		kill_runtime;;
			"" )		;;
			* )		ubb_path=$opt;
					kill_runtime;;
		esac
	done
else
	echo
	echo "$spc $PROD Runtime not installed."
	echo
fi
