REM ************************************************************************
REM * Name        txmon.bb                                                 *
REM * Author      Chris Griffiths                                          *
REM * History:    Date        Ver   Notes                                  *
REM *             14.AUG.2001 1.01  Added code to extract PIDs using files *
REM *             13.AUG.2001 1.0   Blatently plagurised from bbmon        *
REM * Usage:      When run saves ublmon info to a file named "txmon.tx"    *
REM ************************************************************************

   DATA "Jobs" : Declare Headings and PRINT USING masks
   DATA "No. Typ pid... sys4 LineNo  S User............ Program Name.... BBMACHINE. Device.... BBUSER...."
   DATA "D3.0 A1 D3.0 A1 D6.0 A1 D4.0 A1 D6.0 A1 A1 D1.0 A1 A16 A1 A16 A1 A10 A1 A10 A1 A10"
   DATA "Locks"
   DATA  "File Name. FirstB LastB. Id. sys9 pid..."
   DATA "A10 A1 D6.0 A1 D6.0 A1 D3.0 A1 D4.0 A1 D6.0"
   DATA "Files"
   DATA "File Name........... Num Mode..... INode. Device PID(s)"
   DATA "A20 A1 D3.0 A1 A9 A1 D6.0 A1 D6.0 A1 S256"   

   OPEN IOERR FILE [0,1], "TXMON.TX"
   IF IOERR THEN 
      PRINT "ERROR: Could not open file TXMON.TX for output" 
   ELSE 
      GOSUB @init
      GOSUB @jobs
      GOSUB @locks
      GOSUB @files
      CLOSE FILE [0]
   END IF
   END

@jobs
   GOSUB @heading
   INQUIRE ("tables","jobs",X$)
   LET PACKETS=ASC(X$[3,4])
   READ LISTING$
   FOR JOB_OPT=2 TO PACKETS + 1 
      LET X=(JOB_OPT-2)*94
      UNPACK "LJS16S16S10JJJS10S10LJ",X$[X+5],PID,JOB_TYPE,NAME$,PROG_NAME$,DEVICE$,SYS_4,SYS_9,LINE,BBUSER$,BBMACHINE$,STATUS,NEW_LINE
      GOSUB @line_num         : Take advantage of v2.30+ changes to line no.
      PRINT FILE [0] USING LISTING$, SYS_9, " ", JOB_TYPE, " " PID, " ", SYS_4, " ", LINE_NO, PHYSICAL$, " ", STATUS, " ", NAME$, " ", PROG_NAME$, " ", BBMACHINE$, " ", DEVICE$, " ", BBUSER$
   NEXT JOB_OPT
   PRINT FILE [0]
   RETURN

@locks
   GOSUB @heading
   INQUIRE("tables","locks",X$)
   LET PACKETS=ASC(X$[3,4])
   READ LISTING$
   FOR LOCK_OPT=2 TO PACKETS +1
      LET X=(LOCK_OPT-2)*28
      UNPACK "LLLLJS10",X$[X+5],PID,IDEN,POS1,POS2,SYS_9,NAME$
      PRINT FILE [0] USING LISTING$, NAME$, " ", POS1, " ", POS2, " ", IDEN, " ", SYS_9, " ", PID
   NEXT LOCK_OPT
   PRINT FILE [0]
   RETURN

@files
   GOSUB @heading
   INQUIRE ("tables","files",X$)
   LET PACKETS=ASC(X$[3,4]) \    LET X=5 \   LET PACK_LEN=32      
   READ LISTING$
   FOR FILE_OPT=2 TO PACKETS+1
      PID_LIST$=""
      UNPACK "LLJS20J",X$[X],I_NODE,DEV,EXCL,NAME$,SKIP
      IF EXCL=1 THEN MODE$="Exclusive" ELSE MODE$="Shared"
      FOR X=X+PACK_LEN TO X+PACK_LEN+((SKIP-1)*2) STEP 2    : Each PID is stored sequentially at the end of the file entry
         UNPACK "J", X$[X], PID \ LET PID_LIST$[0]=PID, " "
      NEXT X
      LET X=X+2                                             : Move X along the length of the last PID
      PRINT FILE [0] USING LISTING$, NAME$, " ", SKIP, " ", MODE$, " ", I_NODE, " ", DEV, " ", PID_LIST$
   NEXT FILE_OPT
   RETURN
      
@line_num : If v2.30+ and BBSTMT is set, this will show physical line no.'s if no logical ones exist
   IF AND(JOB_TYPE,128) THEN
      IF LINE= 0 THEN
         LET LINE_NO = NEW_LINE \ PHYSICAL$="P"
      ELSE
         IF NEW_LINE <> LINE THEN
            LET LINE_NO = NEW_LINE \ PHYSICAL$="P"
         ELSE
            LET LINE_NO = LINE \ PHYSICAL$=""
         END IF
      END IF
   ELSE
      LINE_NO = LINE
   END IF
   IF LINE_NO = 0 THEN PHYSICAL$=""
   RETURN    

@init
   DIM NAME$[20],PROG_NAME$[16],PHYSICAL$[1],X1$[2], HEADING$[100]
   DIM DEVICE$[10],BBUSER$[10],BBMACHINE$[10],LISTING$[256], MODE$[10], PID_LIST$[256]
   REM * Find out how mutch space needed for buffer *
   INQUIRE ("tables","jobs",X1$)
   LET X=ASC(X1$)*94 \ MAX_JOBS=ASC(X1$)
   INQUIRE ("tables","locks",X1$)
   IF ASC(X1$)*28>X THEN LET X=ASC(X1$)*28
   INQUIRE ("tables","files",X1$)
   IF ASC(X1$)*(32+(MAX_JOBS*2))>X THEN LET X=ASC(X1$)*(32+(MAX_JOBS*2))
   DIM X$[X+5]
   RETURN

@heading
   READ HEADING$  \ HEADING$[0]=FILL$(61) \ PRINT FILE [0] HEADING$
   READ HEADING$  \                         PRINT FILE [0] HEADING$
   RETURN
