#! /bin/sh
#
#   Module name 		: viewenv.sh 
#   Date of last delta		: 12/7/0
#   Release number		: 1.3


# Script name : viewenv.sh
# Purpose     : Views an environment file.
# Author      : S. Roberts
# Revision    : 1.00


PATH=$PATH:. ; export PATH

# Fix to make Linux "echo" process escape characters
os=`uname -s`
if [ "x${os}" = "xLinux" ]
then
	. linfix.sh
fi


set_attrs()
{
	case "$TERM" in
		vt100 | vt220 | vt320 | xterm | ansi )
					st_bl=`tput bold 2>/dev/null`;
					st_us=`tput smul 2>/dev/null`;
					norm=`tput sgr0 2>/dev/null`;;

		* )			st_bl=;
					st_us=;
					norm=;;
	esac
}


menu()
{
	cls.sh
	echo
	echo "$spc DEFAULT Full pathname to BBENV [$st_bl$env_path$norm]   Rev $rev"
	echo "$spc Enter 'q' to QUIT, '^' to GO BACK, 'd' for DEFAULT or NEW FILE"
	echo
}


pause()
{
	echo
	echo "$spc Press [RETURN] to continue: \c"
	read nothing
}


view_env()
{
	if [ -f $env_path ]
	then 
		view $env_path
		ex_flag1=true
	else
		echo
		echo "$spc $env_path not found."
		env_path=$old_path
		pause
	fi
}


find_bbenv()
{
	if [ -n "$BBENV" ]
	then
		env_path=$BBENV
	else
		#env_path=`find / -name BBENV -print 2>/dev/null|head -1`
		env_path=`where.sh BBENV f`
	fi
}


# main
rev="1.00"
set_attrs
spc=""
ex_flag1=false
env_path=""
find_bbenv
menu
while [ $ex_flag1 = false ]
do
	echo "$spc Select option: $st_bl\c"
	read opt
	echo "$norm\c"
	case $opt in
		q | Q )		exit 1;;
		"^" )		exit 2;;
		d | D )		view_env;;
		"" )		;;
		* )		old_path=$env_path
				env_path=$opt;
				view_env;;
	esac
	if [ $ex_flag1 = false ]
	then
		menu
	fi
done
